Index: trunk/LMDZ.TITAN/README
===================================================================
--- trunk/LMDZ.TITAN/README	(revision 1896)
+++ trunk/LMDZ.TITAN/README	(revision 1897)
@@ -1401,2 +1401,9 @@
 Added a bash script ( utilities/prepare_startkim.bash ) to create startfi files
 with upper_chemistry_layers dimension and fill fields from old comp_xx files
+
+== 24/01/18 == JVO
+Major updates in YAMMS and it's coupling from J.Burgalat, including
++ Added the microphysics optical routines and coupling of YAMMS haze with the radiative transfer
++ ... yet you shouldn't activate it yet ( flag uncoupl_optic_haze has to be true ) !
++ Some supplementary safety checks to keep microphysics spitting negative tendencies
++ Other upkeep changes deeper in the library
Index: trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90	(revision 1897)
@@ -1,5 +1,5 @@
-! Copyright Jérémie Burgalat (2010-2015)
+! Copyright Jérémie Burgalat (2010-2015,2017)
 ! 
-! burgalat.jeremie@gmail.com
+! jeremie.burgalat@univ-reims.fr
 ! 
 ! This software is a computer program whose purpose is to provide configuration 
@@ -33,7 +33,7 @@
 
 !! file: argparse.F90
-!! summary: Command-line parser source file
-!! author: burgalat
-!! date: 2013-2015
+!! summary: Command-line parser source file.
+!! author: J. Burgalat
+!! date: 2013-2015,2017
 
 #include "defined.h"
@@ -47,15 +47,10 @@
   !! 
   !! If you only wish to have an overview of argparse usage, you'd better go
-  !! [p_argparse](here).
+  !! [here](|url|/page/swift/p01_argparse.html).
+
   USE, INTRINSIC :: ISO_FORTRAN_ENV, ONLY : stdout=>OUTPUT_UNIT, stderr=>ERROR_UNIT
   USE ERRORS
   USE FSYSTEM, ONLY : fs_termsize
-  USE STRINGS, getpar => format_paragraph, &
-               splitstr  => format_string, & 
-               ap_string  => st_string,    & !! String value type ID
-               ap_complex  => st_complex,  & !! Complex value type ID
-               ap_logical => st_logical,   & !! Logical value type ID
-               ap_integer => st_integer,   & !! Integer value type ID
-               ap_real    => st_real         !! Floating point value type ID 
+  USE STRING_OP, getpar => format_paragraph, splitstr  => format_string  
   IMPLICIT NONE
 
@@ -66,8 +61,5 @@
   PUBLIC :: noerror,error, error_to_string,aborting
   ! from strings
-#if ! HAVE_FTNDTSTR
   PUBLIC :: st_slen, st_llen
-#endif
-  PUBLIC :: ap_string, ap_complex, ap_logical, ap_integer, ap_real
   PUBLIC :: stderr, stdout
   ! argparse module
@@ -92,4 +84,17 @@
   ! PARAMETERS (INTRISIC TYPES)
   ! ===========================
+
+  INTEGER, PARAMETER, PUBLIC :: ap_string  = st_string 
+    !! String value type identifier.
+  INTEGER, PARAMETER, PUBLIC :: ap_complex = st_complex
+    !! Complex value type identifier.
+  INTEGER, PARAMETER, PUBLIC :: ap_logical = st_logical
+    !! Logical value type identifier.
+  INTEGER, PARAMETER, PUBLIC :: ap_integer = st_integer
+    !! Integer value type identifier.
+  INTEGER, PARAMETER, PUBLIC :: ap_real = st_real
+    !! Real value type identifier.
+
+  !> List of all available actions
 
   INTEGER, PARAMETER, PUBLIC :: ap_store  = 1 
@@ -120,4 +125,44 @@
     
   !> Add an option to the parser
+  !!
+  !! ```
+  !! FUNCTION argparser_add_option(this,dest,sflag,lflag,type,action,default,nrec,help,meta) RESULT(err)
+  !!          argparser_add_option(this,dest,flag,type,action,default,nrec,help,meta) RESULT(err)
+  !! ```
+  !!
+  !! The function defines a new argument based on input parameters, checks it and finally sets it 
+  !! in the parser. 
+  !! 
+  !! In its first version both short (`sflag`) and long (`lflag`) options flags are mandatory. In its second
+  !! form, a single flag (`flag`) is expected: the method will automatically deduce if it belongs to short or
+  !! a long option flag based on the number of hyphens given.
+  !! 
+  !! `type` value should be one of the following module constants (which are aliases from [[string_op(module)]]):
+  !!
+  !! - `ap_string` ([[string_op(module):st_string(variable)]])
+  !! - `ap_complex` ([[string_op(module):st_complex(variable)]])
+  !! - `ap_logical` ([[string_op(module):st_logical(variable)]])
+  !! - `ap_integer` ([[string_op(module):st_integer(variable)]])
+  !! - `ap_real` ([[string_op(module):st_real(variable)]])
+  !! 
+  !! `action` value should be one of the following module constants:
+  !!
+  !! - [[argparse(module):ap_store(variable)]]
+  !! - [[argparse(module):ap_append(variable)]]
+  !! - [[argparse(module):ap_count(variable)]]
+  !! - [[argparse(module):ap_help(variable)]]
+  !!
+  !! `nrec` string can take the following forms:
+  !!
+  !! tag   | description
+  !! :---: | : -------------
+  !!  "?"  | zero or one argument's value
+  !!  "*"  | any number of arguments
+  !!  "+"  | one or more argument's value(s)
+  !!  "X"  | Exactly X values. Where X is the string representation of an integer (0 is accepted).
+  !!
+  !! On success, `noerror` is returned. Otherwise -9 error code is returned. Errors are only 
+  !! produced by misuse of the function arguments. In such case, the program should be
+  !! stopped: note that such error should not occur in _released_ programs.
   INTERFACE argparser_add_option
     MODULE PROCEDURE ap_add_option_1, ap_add_option_2
@@ -131,5 +176,10 @@
   !> Get optional argument value(s)
   !!
-  !! This is the generic method that can be used to retrieve any kind of argument value(s) from the parser.
+  !! ```
+  !! FUNCTION argparser_get_value(this,name,output) RESULT(err)
+  !! ```
+  !! 
+  !! This is the generic method that can be used to retrieve any kind of argument value(s) from the parser for a given
+  !! argument name (as defined by the `dest` argument of [[argparse(module):argparser_add_option(interface)]].
   !! All the methods have the same dummy arguments only `output` dummy argument differs in type and shape.
   !! 
@@ -137,5 +187,5 @@
   !! For string vector, `output` is expected to be an allocatable vector of **assumed length**
   !! strings (thus string length is left to user responsability).
-  !! A good compromise for strings length is to use the [[strings(module):st_slen(variable)]] 
+  !! A good compromise for strings length is to use the [[string_op(module):st_slen(variable)]] 
   !! parameter.
   INTERFACE argparser_get_value
@@ -287,6 +337,4 @@
     PROCEDURE, PRIVATE :: ap_get_sv_ve
     PROCEDURE, PRIVATE :: ap_check_state
-    !PROCEDURE, PUBLIC  :: reset_values       => argparser_reset_values
-    !  !! Resets values stored in the parser
     PROCEDURE, PUBLIC  :: throw_error        => argparser_throw_error
       !! Throw an error and exit the program
@@ -415,9 +463,9 @@
 
   FUNCTION argparser_add_positionals(this,nargs,meta,help) RESULT(err)
-    !! Add positional arguments definition to the parser
+    !! Add positional arguments definition to the parser.
+    !!
     !! The method initializes the entry for positional arguments in the parser.
     !! Positional arguments are always seen by the parser as strings and the 
     !! default associated action is 'store'.
-
     OBJECT(argparser), INTENT(inout)                     :: this
       !! An argparser object reference
@@ -533,5 +581,5 @@
     IF (zauto) THEN
       IF (rhelp) CALL argparser_help(this)
-      IF (err /= 0.AND. err /= 255) CALL argparser_throw_error(this,err,2)
+      IF (err /= 0) CALL argparser_throw_error(this,err,2)
     ENDIF
     RETURN 
@@ -751,10 +799,10 @@
     !! in the parser. Both **short and long options flags** are mandatory input arguments of the function.
     !! 
-    !!  `type` value should be one of the following module constants (which are aliases from [[strings(module)]]):
-    !!  - ap_string ([[strings(module):st_string(variable)]])
-    !!  - ap_complex ([[strings(module):st_complex(variable)]])
-    !!  - ap_logical ([[strings(module):st_logical(variable)]])
-    !!  - ap_integer ([[strings(module):st_integer(variable)]])
-    !!  - ap_real ([[strings(module):st_real(variable)]])
+    !!  `type` value should be one of the following module constants (which are aliases from [[string_op(module)]]):
+    !!  - ap_string ([[string_op(module):st_string(variable)]])
+    !!  - ap_complex ([[string_op(module):st_complex(variable)]])
+    !!  - ap_logical ([[string_op(module):st_logical(variable)]])
+    !!  - ap_integer ([[string_op(module):st_integer(variable)]])
+    !!  - ap_real ([[string_op(module):st_real(variable)]])
     !! 
     !!  `action` value should be one of the following module constants:
@@ -772,5 +820,5 @@
     !!   X  | Exactly X values. Where X is the string representation of an integer (0 is accepted).
     !!
-    !! See also [[argparse(module):ap_add_option_2(function)]] documentation.
+    !! See also ap_add_option_2 documentation.
     OBJECT(argparser), INTENT(inout)                     :: this
       !! An argparser object reference
@@ -828,10 +876,10 @@
     !! Add an argument to the parser (interface #2)
     !!
-    !! The function is a wrapper to [[argparse(module):ap_add_option_1(function)]]. In this version, 
+    !! The function is a wrapper to ap_add_option_1. In this version, 
     !! only one option flag is required. The method only checks for the (trimmed) length of **flag** in
     !! order to choose wether it is a **short** or **long** option flag. Then the function simply calls 
-    !! [[argparse(module):ap_add_option_1(function)]] to set the argument.
+    !! ap_add_option_1 to set the argument.
     !! 
-    !! Other dummy arguments have the same meaning as in [[argparse(module):ap_add_option_1(function)]].
+    !! Other dummy arguments have the same meaning as in ap_add_option_1.
     OBJECT(argparser), INTENT(inout)                     :: this
       !! An argparser object reference
@@ -886,5 +934,5 @@
       !! An argc object to check
     TYPE(error) :: err
-      !! Error object with -15 id if object is already set, no error otherwise.
+      !! Error object with -8 id if object is already set, no error otherwise.
     INTEGER :: i
     err = noerror
@@ -914,5 +962,5 @@
       !! An argparser object reference
     TYPE(words), INTENT(inout)               :: cmd
-      !! A [[strings(module):words(type)]] object with the command-line to parse
+      !! A [[string_op(module):words(type)]] object with the command-line to parse
     LOGICAL, INTENT(out)                     :: help_req
       !! An output logical flag with `.true.` if help option has been found, `.false.` otherwise
@@ -987,5 +1035,5 @@
       !! An argparser object reference
     TYPE(words), INTENT(inout)       :: cmd
-      !! A [[strings(module):words(type)]] object with the command-line to parse
+      !! A [[string_op(module):words(type)]] object with the command-line to parse
     TYPE(error) :: err
       !! Error object with the first error encountered in the process
@@ -1068,5 +1116,5 @@
     ! Gets values as a function of the expected number of records
     IF (arg%nrec == 0) THEN
-      ! parse_args (main parsing method) reset all values: for 0 nrec
+      ! argparser_parse (main parsing method) reset all values: for 0 nrec
       ! we should have at least one value saved which is the default.
       ! if it is not the case we set default as values of the argument
@@ -1136,5 +1184,5 @@
     !! @warning
     !! For compilers that does not support allocatable strings in derived types,
-    !! computation are highly dependent of [[strings(module):st_slen(variable):
+    !! computation are highly dependent of [[string_op(module):st_slen(variable):
     !! tokens length are limited by this parameter. 
     IMPLICIT NONE
@@ -1144,5 +1192,5 @@
       !! A string to process
     TYPE(words), INTENT(out)      :: new_cmd
-      !! An output [[strings(module):words(type)]] object with the processed command line
+      !! An output [[string_op(module):words(type)]] object with the processed command line
     LOGICAL, INTENT(out)          :: rhelp   
       !! An output boolean flag with `.true.` if help is requested, `.false.` otherwise
@@ -1155,9 +1203,9 @@
     err = noerror ; rhelp = .false.
     IF (LEN_TRIM(string) == 0) THEN
-      err = error('internal error (empty string)',-2) 
+      err = error('internal error (empty string)',-255) 
       RETURN
     ENDIF
     ! split input command line in words !
-    splitted = new_words(string," ",.true.) ! tokens may be truncated :( 
+    call words_extend(splitted,string," ",.true.)
     ! reset iterator
     CALL words_reset(splitted)
@@ -1330,5 +1378,6 @@
 
   SUBROUTINE ap_format_usage(this,optmw)
-    !! Format command line usage
+    !! Format command line usage.
+    !!
     !! The subroutine creates and formats the command line usage of the 
     !! given argparser object. If [[argparser(type):usg(variable)]] is already set (i.e. not empty) 
@@ -1693,6 +1742,8 @@
     !! The function calls all the tests to perform on argc members. Some of these tests can 
     !! alter argc's member values to fit argparser's requirements. 
-    !! @note
-    !! Normally, program should be stopped if returned error is not 0 !
+    !!
+    !! On success, `noerror` is returned. Otherwise -9 error code is returned. Errors are only 
+    !! produced by misuse of the function arguments. In such case, the program should be
+    !! stopped: note that such ezrror should not occur in _released_ programs.
     TYPE(argc), INTENT(inout)                            :: this
       !! An argc object
@@ -1740,4 +1791,7 @@
     !! The method checks if input argument's options are valid and update the argc object 
     !! consequently. 
+    !!
+    !! On success, `noerror` is returned. Otherwise -9 error code is returned. Errors are only 
+    !! produced by misuse of the function arguments.
     TYPE(argc), INTENT(inout)  :: this
       !! An argc object to update
@@ -1756,6 +1810,6 @@
     ret = noerror
     eprf = 'argparse: '//"Invalid argument `"//TRIM(this%name)//"'"
-    uty = error(eprf//" (type)",-2) 
-    ina = error(eprf//" (inconsistent nargs)",-2)
+    uty = error(eprf//" (type)",-9) 
+    ina = error(eprf//" (inconsistent nargs)",-9)
     zna = TRIM(na)
     ! Checks action
@@ -1763,5 +1817,5 @@
       this%paction = ac 
     ELSE
-      ret = error(eprf//" (action)",-2) ; RETURN 
+      ret = error(eprf//" (action)",-9) ; RETURN 
     ENDIF
     ! Checks and sets type and default as a function of the action
@@ -1885,5 +1939,5 @@
             terr = error(eprf//" (inconsistent default value: expected '"// &
                            TRIM(st_type_names(this%ptype))//"', found '"// &
-                           TRIM(st_type_names(t))//"')",-2)
+                           TRIM(st_type_names(t))//"')",-9)
             RETURN
           ENDIF
@@ -1977,5 +2031,5 @@
       SELECT CASE(this%nrec)
         CASE(-3,-2,-1)
-          zmeta = str_to_upper(meta(1))
+          zmeta = to_upper(meta(1))
           blk = INDEX(TRIM(zmeta),CHAR(32)) - 1
           IF (blk <= 0) blk=LEN_TRIM(zmeta)
@@ -1987,5 +2041,5 @@
           DO i=1,this%nrec
             j=j+1 ; IF (j>ms) j=1
-            zmeta = str_to_upper(meta(j))
+            zmeta = to_upper(meta(j))
             blk=INDEX(TRIM(zmeta),CHAR(32))-1 
             IF (blk <= 0) blk=LEN_TRIM(zmeta)
@@ -1994,5 +2048,5 @@
       END SELECT
     ELSE
-      zmeta = str_to_upper(TRIM(this%name))
+      zmeta = to_upper(TRIM(this%name))
       SELECT CASE(this%nrec)
         CASE(-3,-2,-1)
@@ -2223,5 +2277,5 @@
     !! - -7  : argument not found (i.e. does not set in the parser)
     !! - -19 : parsing not done yet
-    !! - -20 : (previous) parsing failed
+    !! - -20 : parsing failed
     !! - -21 : inconsistent destination type
     !! @note
@@ -2480,5 +2534,5 @@
   !! @param[in,out] this An argc object 
   !! @param[out] output A scalar with the first value of the argument
-  !! @return An errors::error object with -12 if the destination variable's type
+  !! @return An errors::error object with -21 if the destination variable's type
   !! is inconsistent, 0 otherwise.
   FUNCTION ac_get_dv_sc(this, output) RESULT(ret)
@@ -2492,5 +2546,5 @@
       !! Output value
     TYPE(error) :: ret
-      !! Error object with the -12 if the destination variable's type is inconsistent, 0 otherwise
+      !! Error object with the -21 if the destination variable's type is inconsistent, 0 otherwise
     ret = noerror
     IF (this%ptype /= ap_real) THEN
Index: trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90	(revision 1897)
@@ -1,5 +1,5 @@
-! Copyright Jérémie Burgalat (2010-2015)
-! 
-! burgalat.jeremie@gmail.com
+! Copyright Jérémie Burgalat (2010-2015,2017)
+! 
+! jeremie.burgalat@univ-reims.fr
 ! 
 ! This software is a computer program whose purpose is to provide configuration 
@@ -32,8 +32,8 @@
 ! knowledge of the CeCILL-B license and that you accept its terms.
 
-!! file: asciiread.F90
+!! file: asciiread.f90
 !! summary: ASCII data file reader source file
 !! author: burgalat
-!! date: 2013-2015
+!! date: 2013-2015,2017
 MODULE ASCIIREAD
   !! ASCII data file reader module
@@ -42,5 +42,5 @@
   !! data array from ASCII file.
   !!
-  !! ```fortran 
+  !! ``` 
   !! FUNCTION read_data(path,data) RESULT(err)
   !! ```
@@ -65,5 +65,5 @@
   !!
   !! - path does not refer to a existing file (1)
-  !! - Logical unit 666 is not free (1)
+  !! - No free logical unit available (1)
   !! - the file does not have regular data-columns number (5)
   !! - at least a value cannot be cast in double precision (5)
@@ -79,5 +79,6 @@
   !! On success, the shape of the 3D output array will be _data(R,C,D)_.
   USE, INTRINSIC :: ISO_FORTRAN_ENV, ONLY: IOSTAT_END, IOSTAT_EOR
-  USE STRINGS, ONLY: tokenize,from_string, st_slen
+  !USE STRING_OP, ONLY: tokenize,from_string, st_slen
+  USE STRING_OP
   USE ERRORS
   IMPLICIT NONE
@@ -85,5 +86,5 @@
   PRIVATE
   PUBLIC :: noerror,error, error_to_string,aborting
-  PUBLIC :: read_data, OPERATOR(/=), OPERATOR(==)
+  PUBLIC :: readline,read_data, OPERATOR(/=), OPERATOR(==)
 
   !! Global interface to reading methods
@@ -110,5 +111,5 @@
     !! Error occured when:
     !!    - Path does not refer to a existing file (-11)
-    !!    - No free logical unit available (-12)
+    !!    - No free logical unit available (-1)
     !!    - The file does not have regular data-columns number (-5)
     !!    - At least a value cannot be cast in double precision (-10)
@@ -120,7 +121,4 @@
     !! On success, the shape of the 3D output array will be _output(R,C,D)_.
     !! On error, the 3D output array is __not allocated__.
-    !!
-    !! @note
-    !! The function uses the logical unit 666 !
     CHARACTER(len=*), INTENT(in)                             :: path      !! Path of the input data file 
     REAL(kind=8), INTENT(out), DIMENSION(:,:,:), ALLOCATABLE :: data3d    !! 3D-array with the output values (double precision)
@@ -130,5 +128,5 @@
     INTEGER                                           :: i,lc,tlc
     INTEGER                                           :: ndr,ndc,ndd
-    INTEGER                                           :: ir,jc,kd
+    INTEGER                                           :: ir,jc,kd,lu
     REAL(kind=8), DIMENSION(:), ALLOCATABLE           :: tmp
     CHARACTER(len=5)                                  :: slc
@@ -144,10 +142,8 @@
       err = error(trim(path)//": no such file",-1) ; RETURN
     ENDIF
-    INQUIRE(unit=666,OPENED=ok)
-    IF (ok) THEN
-      err = error("lun 666 is already used",-1) ; RETURN
-    ENDIF
+    lu = free_lun() 
+    IF (lu == -1) THEN ; err = error("Cannot find available logical unit...",-1) ; RETURN ; ENDIF
     ! Open file
-    OPEN(666,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
+    OPEN(lu,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
 
     ! First pass : 
@@ -158,5 +154,5 @@
     lc = 0 ; tlc = 0 
     ndr = -1 ; ndc = -1 ; ndd = 1 
-    DO WHILE(readline(666,line)) 
+    DO WHILE(readline(lu,line)) 
       lm1 = line
       ! Read the line
@@ -193,4 +189,6 @@
       ENDIF
       IF (ndc == -1) ndc = SIZE(wrds)
+      IF (ALLOCATED(wrds)) DEALLOCATE(wrds)
+      IF (ALLOCATED(tmp)) DEALLOCATE(tmp)
     ENDDO
 
@@ -203,9 +201,9 @@
 
     ! Rewind input data file
-    REWIND(666)
+    REWIND(lu)
     ! Allocate memory
     ALLOCATE(data3d(ndr,ndc,ndd))
     ir = 0 ; kd = 1 ; 
-    DO WHILE(readline(666,line)) 
+    DO WHILE(readline(lu,line)) 
       IF (INDEX(TRIM(ADJUSTL(line)),"#") == 1) CYCLE
       ir = ir + 1
@@ -216,6 +214,7 @@
       ok = tokenize(line,wrds,zdelim,.true.)
       DO jc = 1,ndc ; ok = from_string(wrds(jc),data3d(ir,jc,kd)) ; ENDDO
-    ENDDO
-    CLOSE(666)
+      IF (ALLOCATED(wrds)) DEALLOCATE(wrds)
+    ENDDO
+    CLOSE(lu)
   END FUNCTION read_data_3d
 
@@ -236,11 +235,10 @@
     !!
     !! - Path does not refer to a existing file (-1)
-    !! - Logical unit 666 is not free (-1)
+    !! - No free logical unit available (-1)
     !! - The file does not have regular data-columns number (-5)
     !! - At least a value cannot be cast in double precision (-5)
     !!
     !! On error, the 2D output array is __not allocated__.
-    !! @note
-    !! The function uses the logical unit 666 !
+    USE FSYSTEM
     CHARACTER(len=*), INTENT(in)                           :: path      !! Path of the input data file 
     REAL(kind=8), INTENT(out), DIMENSION(:,:), ALLOCATABLE :: data2d    !! 2D-array with the output values (double precision)
@@ -249,22 +247,18 @@
     LOGICAL                                           :: ok
     INTEGER                                           :: i,e,vc,lc
-    INTEGER                                           :: nl,nc
+    INTEGER                                           :: nl,nc,lu
     REAL(kind=8), DIMENSION(:), ALLOCATABLE           :: tmp
     CHARACTER(len=5)                                  :: slc
     CHARACTER(len=:), ALLOCATABLE                     :: line,zdelim
     CHARACTER(len=st_slen), DIMENSION(:), ALLOCATABLE :: wrds
-
     zdelim = CHAR(9)//CHAR(32)
     IF (PRESENT(delimiter)) zdelim = delimiter
-    ! Gets array size
     INQUIRE(FILE=TRIM(path),EXIST=ok)
     IF (.NOT.ok) THEN
       err = error(trim(path)//": no such file",-1) ; RETURN
     ENDIF
-    INQUIRE(unit=666,OPENED=ok)
-    IF (ok) THEN
-      err = error("lun 666 is already used",-1) ; RETURN
-    ENDIF
-    OPEN(666,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
+    lu = free_lun() 
+    IF (lu == -1) THEN ; err = error("Cannot find available logical unit...",-1) ; RETURN ; ENDIF
+    OPEN(lu,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
     vc = 0 ; lc=0 ; ok = .true.
     ! Read the file twice :)
@@ -273,5 +267,5 @@
     DO 
       ! Read the line
-      IF (.NOT.readline(666,line)) EXIT
+      IF (.NOT.readline(lu,line)) EXIT
       lc = lc + 1 ; WRITE(slc,'(I5)') lc ; slc = ADJUSTL(slc)
       ! skip empty/comment line
@@ -279,5 +273,4 @@
       ! update row counter
       vc = vc + 1
-      ! Splits line in words
       IF (.NOT.tokenize(line,wrds,zdelim,.true.)) THEN 
         ! cannot tokenize
@@ -286,9 +279,7 @@
       ELSEIF (.NOT.from_string(wrds,tmp)) THEN
         ! cannot cast values
-        do i=1,size(wrds) ; write(*,*) trim(wrds(i)) ; enddo
-        write(1111,'(a)') line
         err = error(trim(path)//": Cannot cast values at line "//TRIM(slc),-5)
         RETURN
-      ELSEIF (nc > 0 .AND. nc /= SIZE(wrds)) THEN 
+      ELSEIF (nc > 0 .AND. nc /= SIZE(tmp)) THEN 
         ! current number of columns not equal to last one
         err = error(trim(path)//": Invalid number of columns (line "//TRIM(slc)//")",-5)
@@ -296,7 +287,9 @@
       ENDIF
       IF (nc == -1) nc = SIZE(wrds)
+      IF (ALLOCATED(wrds)) DEALLOCATE(wrds)
+      IF (ALLOCATED(tmp)) DEALLOCATE(tmp)
     ENDDO
     ! Rewind input data file
-    REWIND(666)
+    REWIND(lu)
     nl = vc
     ! allocate memory
@@ -306,5 +299,5 @@
     DO WHILE(vc <= nl)
       ! Reads the line
-      IF (.NOT.readline(666,line)) EXIT
+      IF (.NOT.readline(lu,line)) EXIT
       ! Check if we have comment or null string
       IF (INDEX(TRIM(ADJUSTL(line)),"#") == 1.OR.LEN_TRIM(line) == 0) CYCLE
@@ -314,6 +307,7 @@
         ok = from_string(wrds(i),data2d(vc,i))
       ENDDO
-    ENDDO
-    CLOSE(666)
+      IF (ALLOCATED(wrds)) DEALLOCATE(wrds)
+    ENDDO
+    CLOSE(lu)
     RETURN
   END FUNCTION read_data_2d
@@ -327,5 +321,5 @@
     !! The function is intended to read a file line by line:
     !!
-    !! ```fortran
+    !! ```
     !! lu = 1
     !! open(lu,file="path/to/the/file/to/read")
@@ -358,3 +352,3 @@
   END FUNCTION readline
 
-END MODULE
+END MODULE ASCIIREAD
